/***************************************************************************
                          shmap_fifo.h  -  description
                             -------------------
    begin                : Sat Apr 27 2002
    copyright            : (C) 2002 by Margus Laak
    email                : margus@mail.ee
 ***************************************************************************/

/***************************************************************************
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA *
 ***************************************************************************/


#ifndef _SHMAP_FIFO_I
#define _SHMAP_FIFO_I
#include "shmap.h"
#include "shmap_internals.h"


#define SHMAP_FIFO_MODULE "Shmap fifo type module"
#define SHMAP_FIFO_VERSION "0.1"

typedef struct _shmap_fifo_list _shmap_fifo_list;
struct _shmap_fifo_list
{
        _shmap_value     * value;
        _shmap_fifo_list * next;
};


typedef struct _shmap_fifo _shmap_fifo;
struct _shmap_fifo
{
        _shpool            * pool;
        _shmap_fifo_list   * toplevel;
};

void         * shmap_fifo_init ( void * p_mem, void * p_opts );
int            shmap_fifo_add_value ( shmap * map, const char * key, void * value, int opts, shmap_cleanup cleanup );
_shmap_value * shmap_fifo_get_value ( shmap * map, const char * key, int cache );
int            shmap_fifo_del_value ( shmap * map, const char * key, shmap_cleanup cleanup );
_shmap_value * shmap_fifo_get_sub ( shmap * map, const char * key, int keylen, int pos, int cached );
int            shmap_fifo_del_sub ( shmap * map, const char * key, int keylen, shmap_cleanup cleanup );
int            shmap_fifo_clear ( shmap * map, shmap_cleanup cleanup );
int            shmap_fifo_dispose ( shmap * map, shmap_cleanup cleanup );

void           _shmap_fifo_del ( _shmap_fifo * fifo );
void           _shmap_fifo_cleanup ( _shmap_value * value, int * opts );
_shmap_value * _shmap_fifo_get ( _shmap_fifo * fifo );
_shmap_fifo  * _shmap_fifo_init ( void * p_mem );
int            _shmap_fifo_add ( _shmap_fifo * fifo, void * value, int opts );

#endif