/***************************************************************************
                          shmap_hm.h  -  description
                             -------------------
    begin                : Wed Feb 6 2002
    copyright            : (C) 2002 by Margus Laak
    email                : margus@mail.ee
 ***************************************************************************/

/***************************************************************************
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA *
 ***************************************************************************/



#ifndef _SHMAP_HM_I
#define _SHMAP_HM_I

#include <stdlib.h>

#include "shmap.h"
#include "shmap_internals.h"

typedef struct _shmap_hm_entry  _shmap_hm_entry;

// how many cells of pointer does one row hold
#define SHMAP_HM_VALUES 2048
// the module name
#define SHMAP_HM_MODULE   "Shmap HM module"
#define SHMAP_HM_VERSION  "0.1"

/*
        API functions
*/

void *         shmap_hm_init ( void *, void * );
_shmap_value * shmap_hm_get_value ( shmap *, const char *, int );
int            shmap_hm_get_int ( shmap *, const char *, int *, int );
int            shmap_hm_add_value ( shmap *, const char *, void *, int, shmap_cleanup );
int            shmap_hm_del_value ( shmap *, const char *, shmap_cleanup );
_shmap_value  * shmap_hm_get_sub ( shmap *, const char *, int, int, int );
int            shmap_hm_del_sub ( shmap *, const char *, int, shmap_cleanup );
int            shmap_hm_clear ( shmap *, shmap_cleanup );
int            shmap_hm_dispose ( shmap *, shmap_cleanup );
void           shmap_hm_empty_cache ( shmap * );
unsigned int   shmap_hm_available ( shmap * );
void           shmap_hm_dump ( shmap *, int );

/*
        internal core functions
*/

_shmap_hm_entry  * _shmap_hm_core_init ( void * );
_shmap_value     * _shmap_hm_core_get_value ( void *, const char * );
int                _shmap_hm_core_add_value ( void *, void *, const char *, void *, int opts, shmap_cleanup );
int                _shmap_hm_core_del_value ( void *, void **, const char *, shmap_cleanup );
_shmap_value     * _shmap_hm_core_get_sub ( void *, const char *, int, int );
int                _shmap_hm_core_del_values ( void *, void **, shmap_cleanup );
_shmap_value     * _shmap_hm_core_entry ( void *, const char *, const char *, int );
_shmap_hm_entry  * _shmap_hm_core_newlevel ( void *, _shmap_hm_entry * );
int                _shmap_hm_core_del_entrylevel ( void *, _shmap_hm_entry *, int force, shmap_cleanup );

#endif
