/***************************************************************************
                          shmap_ll.h  -  description
                             -------------------
    begin                : Wed Feb 6 2002
    copyright            : (C) 2002 by Margus Laak
    email                : margus@mail.ee
 ***************************************************************************/

/***************************************************************************
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA *
 ***************************************************************************/



#ifndef _SHMAP_LL_I
#define _SHMAP_LL_I

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#include "shmap.h"
#include "shmap_internals.h"

#define SHMAP_LL_MODULE   "Shmap LinkedList module"
#define SHMAP_LL_VERSION  "0.1"

typedef struct _shmap_entry _shmap_entry;

void *         shmap_ll_init ( void *, void * );
_shmap_value * shmap_ll_get_value ( shmap * , const char * , int );
int            shmap_ll_get_int ( shmap * , const char * , int * , int );
int            shmap_ll_add_value ( shmap * , const char * , void *, int val_opts, shmap_cleanup cleanup );
int            shmap_ll_del_value ( shmap * , const char *, shmap_cleanup );
_shmap_value * shmap_ll_get_sub ( shmap * , const char * , int , int , int );
int            shmap_ll_del_sub ( shmap * , const char * , int, shmap_cleanup );
int            shmap_ll_clear ( shmap *, shmap_cleanup );
int            shmap_ll_dispose ( shmap *, shmap_cleanup );
void *         shmap_ll_cache_init ( void * );
void           shmap_ll_cache_clean ( void * );
int            shmap_ll_cache_dispose ( void * , void **  );
void           shmap_ll_dump ( shmap * , int );

#ifdef __SHMAP_LL_NEED_CORE
static _shmap_entry * _shmap_core_get_entry ( _shmap_entry *, int, const char * );
static int            _shmap_core_add_entry ( _shmap_entry **, _shmap_entry * );
static int            _shmap_core_del_entry ( _shmap_entry **, _shmap_entry * );
static _shmap_entry * _shmap_core_get_subentry ( _shmap_entry *, int, const char *, int, int );
static int            _shmap_delv ( shmap *, shmap_cleanup );
static int            _shmap_core_replace_value ( void * p_mem, _shmap_entry *, int, const char *, const char *, shmap_cleanup );
#endif



#endif
